/***************************************************************************
****************************************************************************

This is a part of the xModule Source code.

Copyright (C) 2003-2006 The LS-Universe Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************
****************************************************************************/

#if !defined(AFX_BUTTONFONT_H__6AECC40F_E363_498B_B876_2255874F62D8__INCLUDED_)
#define AFX_BUTTONFONT_H__6AECC40F_E363_498B_B876_2255874F62D8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

struct FONTSETTINGS
{
	bool showText;

	int leftBorder;
	int topBorder;
	int rightBorder;
	int bottomBorder;

	string name;
	short charSet;
	int height;
	int color;

	bool bold;
	bool italic;
	bool underline;
	bool noellipsis;

	bool shadow;
	int shadowX;
	int shadowY; 
	int shadowcolor;

	bool textoutline;
	bool textoutlineextra;
	int textoutlinecolor;

	int align;
	int vertalign;

	bool smoothing;
	bool clearType;
};  

class ButtonFont  
{
public:
	ButtonFont();
	virtual ~ButtonFont();

	void configure(const string &uniquekey, const string &groupkey);
	void apply(HDC hDC, int x, int y, int width, int height, const string &caption, int buttonType);
	POINT measure(string TextLine, int type = 0);

private:

	void subconfigure(const string &uniquetype, const string &grouptype, const string &prefixkey, FONTSETTINGS &workSettings, FONTSETTINGS &defaultSettings);

	void createHandle(FONTSETTINGS processFont, HFONT &processhfont);
	void drawOutline(HDC destHDC, RECT tmpr, int align, int vertalign, const string &caption, bool outlineextra, bool noEllipsis);

	bool useTextArrow;
	string arrowText;
	string selarrowText;

	HFONT titleFont;
	HFONT infoFont;
	HFONT entryFont;
	HFONT selentryFont;
	HFONT folderFont;
	HFONT selfolderFont;
	HFONT arrowFont;
	HFONT selarrowFont;

	FONTSETTINGS defaultfont;
	FONTSETTINGS title;
	FONTSETTINGS info;
	FONTSETTINGS entry;
	FONTSETTINGS selentry;
	FONTSETTINGS folder;
	FONTSETTINGS selfolder;
	FONTSETTINGS arrow;
	FONTSETTINGS selarrow;
};

#endif // !defined(AFX_BUTTONFONT_H__6AECC40F_E363_498B_B876_2255874F62D8__INCLUDED_)
